routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
  |--------------------------------------------------------------------------
  | Web Routes
  |--------------------------------------------------------------------------
  |
  | Here is where you can register web routes for your application. These
  | routes are loaded by the RouteServiceProvider within a group which
  | contains the "web" middleware group. Now create something great!
  |
 */
Auth::routes();

Route::get('/', 'HomeController@index')->name('home.index');
Route::get('/registerc', 'Auth\RegisterController@registerc')->name('register.registerc');
//Route::resource('users', 'UserController')->middleware('auth');
//Route::get('categoriasu', 'CategoriasUserController@index');

Route::get('recuperarpassword/{hash}', 'Auth\ResetPasswordController@resetpassword')->name('user.resetpassword');
Route::post('enviarlink/password', 'Auth\ResetPasswordController@resetpasswordhash')->name('usuario.sendlinkpassword');
Route::post('actualizar/password', 'Auth\ResetPasswordController@updatepassword')->name('usuario.updatepassword');

Route::middleware(['auth'])->group(function () {

    /* Route::get('inicio', function () {
      return view('welcome');
      })->name('inicio'); */

    Route::resource('users', 'UserController'); //CRUD
    Route::resource('categoriasu', 'CategoriasUserController'); //CRUD s
    Route::resource('productos', 'ProductoController'); //CRUD
    Route::resource('links', 'LinkController'); //CRUD

    Route::post('productos/{producto}/duplicate', 'ProductoController@duplicate')->name('productos.duplicate');

    Route::post('productos/{producto}/linkear', 'ProductoController@linkear')->name('productos.linkear');

    Route::resource('configuracion', 'ConfiguracionController'); //CRUD

    Route::get('cargamasiva', 'CargaMasivaController@index')->name('cargamasiva.index');
    Route::get('cargamasiva/plantilla', 'CargaMasivaController@downloadtemplate')->name('cargamasiva.template');
    Route::post('cargamasiva/procesar', 'CargaMasivaController@process')->name('cargamasiva.proccess');

    Route::get('cargamasiva/users', 'CargaMasivaController@indexusers')->name('userscargamasiva.index');
    Route::get('cargamasiva/plantilla/usuarios', 'CargaMasivaController@downloadtemplateusers')->name('cargamasivausers.template');
    Route::post('cargamasiva/procesar/usuarios', 'CargaMasivaController@processusers')->name('cargamasivausers.proccess');

    Route::get('soporte/create', 'SoporteController@create')->name('soporte.create');
    Route::post('soporte/create/process', 'SoporteController@createprocess')->name('soporte.createprocess');

    Route::get('datosbancarios', 'DatosBancariosController@create')->name('datosbancarios.create');
    Route::post('datosbancarios/create/procesar', 'DatosBancariosController@createprocess')->name('datosbancarios.createprocess');
    Route::get('datosbancarios/{users}', 'DatosBancariosController@show')->name('datosbancarios.show');

    //Route::get('users', 'UserController@linkpago')->name('users.linkpago');

    Route::get('perfil/edit', 'PerfilController@edit')->name('perfil.edit');
    Route::post('perfil/edit/process', 'PerfilController@editprocess')->name('perfil.editprocess');

    Route::post('perfil/edit/setshopify', 'PerfilController@setshopify')->name('perfil.setshopify');

    Route::post('users/{user}/updateurl', 'UserController@updateurl')->name('users.updateurl');

    Route::get('pagos/', 'PagosController@index')->name('pagos.index');
    Route::post('pagos/spa', 'PagosController@spa')->name('pagos.spa');
    Route::post('pagos/spl', 'PagosController@spl')->name('pagos.spl');
    Route::get('pagos/{pagos}/edit', 'PagosController@edit')->name('pagos.edit');
    Route::put('pagos/{pagos}/update', 'PagosController@update')->name('pagos.update');
    //Route::get('categoriasComercios/{cc}', 'CategoriasUserController@show')->name('categoriasComercios');

    Route::post('categoriaproducto/create', 'CategoriascController@create')->name('categoriaproductos.create');
    Route::post('categoriaproducto/eliminar', 'CategoriascController@eliminar')->name('categoriaproductos.delete');
});

//Route::resource('users', 'UserController');
//Route::get('users','UserController@index');
//Route::post('users','UserController@store')->name('users.store');
//Route::delete('users/{user}','UserController@destroy')->name('users.destroy');

app/Productos.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\Auth;

class Productos extends Model
{
    //
    //protected $primaryKey = 'idproductos';

    protected $fillable = [ 
        'nombre_p', 'web', 'url_web', 'descripcion', 'porcentaje_a', 'cp_id', 'codigo', 'users_id', 'valor', 'conversion', 'sku'
    ];

    protected $hidden = [
        'codigo', 'users_id'
    ];

    public function categoriap() 
    {
        return $this->belongsTo(CategoriasProductos::class, 'cp_id');
    }

    public function username() 
    {
        return $this->belongsTo(User::class, 'users_id');
    }

    public function productofotos()
    {
        return $this->hasMany(FotosProductos::class);
    }

    public function getVisitaspAttribute()
    {   
        $visitas = VisitasProductos::
        where('productos_id', '=', $this->id)
        ->first();

        if($visitas)
            return $visitas->visitas;
        else 
            return 0;
    }

    public function getImagenlistAttribute($value)
    {
        //$fotos = $value->productofotos;
        if(!empty($this->productofotos[0]->url_imagen)) {
            if($this->productofotos[0]->tipo == 'IN')
                $url = url('storage/app/public/'.$this->productofotos[0]->url_imagen);
            else 
                $url = $this->productofotos[0]->url_imagen;

            return '<img src="'.$url.'" alt="user" class="img-circle float-left m-t-5">'; 
        } else {
            return '<img src="https://www.syncros.com/_ui/responsive/common/images/no-product-image-available.png" alt="user" class="img-circle float-left m-t-5">';         
        }
    }

    public function setCodigoAttribute($value) 
    {
        $length = 10;
        $characters = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ';
        $charactersLength = strlen($characters);
        $randomString = '';
        for ($i = 0; $i < $length; $i++) {
            $randomString .= $characters[rand(0, $charactersLength - 1)];
        }
        return $this->attributes['codigo'] = $randomString;
    }   

    public function getCalculovalorAttribute()
    {
        $configuracion = Configuraciones::
        where('id', '=', 1)
        ->first();

        return $this->porcentaje_a - (($this->porcentaje_a * $configuracion->comision) / 100);
    }

    public function getYalinkeadoAttribute()
    {
        $links = Links::
        where([
            ['productos_id', '=', $this->id],
            ['users_id', '=', Auth::user()->id],
        ])
        ->first();
        
        if($links && Auth::user()->cc_id == 2){

            $link = $this->url_web.'?codigo='.$this->codigo.'-'.$links->codigo;

            return '<div class="box-link m-t-5 box-linkeado" data-link="'.$link.'">
                        <div style="display:block">
                            <a href="'.$link.'" target="_blank">
                                <i class="fa fa-link float-left"></i> 
                            </a>
                            <div class="float-right">'.$this->codigo.'</div>
                            <div style="clear:both"></div>
                        </div>
                    </div>';
        } else {
            $link = $this->url_web.'?codigo='.$this->codigo;

            return '<a href="'.$link.'" target="_blank">
                        <div class="box-link m-t-5">
                            <div style="display:block">
                                <i class="fa fa-link float-left"></i> 
                                <div class="float-right">'.$this->codigo.'</div>
                                <div style="clear:both"></div>
                            </div>
                        </div>
                    </a>';
        }
    }

}

resources/views/productos/afiliado/index.blade.php
@extends('layout') 
@section('content')
<div class="container-fluid p-t-20">
    <div class="row">
        <div class="col-12">            
            <div class="">
                <div class="card-body">
                    <h2 class="card-title">Productos</h2>
                    <h6 class="card-subtitle">Lista de productos</h6>
                    <br/>
                    <div class="row">
                        <div class="col-md-12">                          
                            <a href="{{ route('links.index') }}" class="btn-md btn-info float-left btn-especial">
                                Mis Links 
                            </a>
                            <a href="#" class="btn-md btn-outline-primary float-right btn-especial btn-search">
                               Organizar 
                               <i class="fa fa-angle-up"></i>
                            </a>
                            <a href="#" class="btn-md btn-primary float-right btn-especial btn-search-open" style="display:none">
                               Organizar 
                               <i class="fa fa-angle-down"></i>
                            </a>
                            <div class="search_float">
                                <div class="card">
                                    <div class="card-body">
                                        <form action="{{ route('productos.index') }}" method="GET" class="form-horizontal" enctype="multipart/form-data">
                                            <div class="form-body">
                                                <h6 class="box-title">Filtrar por:</h6>
                                                <hr class="m-t-0 m-b-5">
                                                <div class="row">
                                                    <div class="col-md-12">
                                                        <div class="form-group row">
                                                            <label class="control-label text-right col-12">Ordenar productos</label>
                                                            <div class="col-12">
                                                                <select class="form-control custom-select" name="orden_p">     
                                                                    <option value="DESC">Descendiente</option>
                                                                    <option value="ASC">Ascendiente</option>
                                                                </select>
                                                            </div>
                                                        </div>             
                                                        <div class="form-group row">
                                                            <label class="control-label text-right col-md-12">Categoria</label>
                                                            <div class="col-md-12">
                                                                <select class="form-control custom-select" name="cp_id">
                                                                    <option value="">Seleccione</option>
                                                                    @foreach($cc as $item)
                                                                    <option value="{{$item->id}}" @if( $item->id == old('cp_id') ) {!! _('selected') !!} @endif >{{$item->nombre_cp}}</option>
                                                                    @endforeach
                                                                </select>
                                                            </div>
                                                        </div>             
                                                    </div>

                                                    <div class="col-12"> 
                                                        <div class="form-group row">
                                                            <label class="control-label text-right col-12">Valor</label>
                                                            <div class="col-12 input-group"> 
                                                                <div class="price-slider"><span>de
                                                                    $<input type="number" value="0" min="0" max="2500" name="valor_i"/> a
                                                                    $<input type="number" value="500" min="0" max="2500" name="valor_f"/></span>

                                                                    <input type="hidden" id="valor" name="valor" value="false"/></span>

                                                                    <input value="0" min="0" max="2500" step="10" type="range"/>
                                                                    <input value="500" min="0" max="2500" step="10" type="range"/>

                                                                    <svg width="100%" height="24">
                                                                        <line x1="4" y1="0" x2="300" y2="0" stroke="#212121" stroke-width="12" stroke-dasharray="1 28"></line>
                                                                    </svg>
                                                                </div>
                                                            </div>
                                                        </div> 
                                                    </div>
                                                </div>  
                                                
                                                <div class="form-actions">
                                                    <div class="row">
                                                        <div class="col-md-12">
                                                            @csrf   
                                                            <button type="submit" class="btn-md btn-primary m-r-10 mx-auto" style="display: block;">Buscar</button>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>                        
                                        </div>
                                    </div>                                    
                                </form>
                            </div>
                        </div>
                    </div>
                    <br/>
                    <div class="row">
                        <div class="col-12">
                            <div class="card p-2">
                                <div class="row">
                                    <div class="col-1"></div>
                                    <div class="col-3 border-right font-size-11">Nombre producto</div>
                                    <div class="col-2 border-right font-size-11">Categor&iacute;a</div>
                                    <div class="col-1 border-right font-size-11">Precio</div>
                                    <div class="col-1 border-right font-size-11">Comisión</div>
                                    <div class="col-2 border-right font-size-11">Link producto</div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="row">
                        @foreach($productos as $item)
                        <div class="col-12">
                            <div class="card p-2">
                                <div class="row">
                                    <div class="col-1 content-img-p center-conent-v">
                                        {!! $item->imagenlist !!}
                                    </div> 
                                    <div class="col-3 border-right center-conent-v">
                                        <h4 style="font-weight: bold;">
                                            {{$item->nombre_p}}                                       
                                        </h4> 
                                    </div>
                                    <div class="col-2 border-right center-conent-v">
                                        {{$item->categoriap->nombre_cp}}
                                    </div>
                                    <div class="col-1 border-right center-conent-v">
                                        ${{$item->valor}}
                                    </div>
                                    <div class="col-1 border-right center-conent-v text-calculovalor">
                                        {{$item->calculovalor}}%
                                    </div> 
                                    <div class="col-2 border-right center-conent-v">
                                        {!! $item->yalinkeado !!}
                                    </div>   
                                    <div class="col-2 center-conent-v">
                                        <div class="btn-group float-left" role="group">  
                                            <a href="{{ route('productos.show', $item) }}" class="btn btn-primary btn-especial" style="max-width: 100px;margin: auto;">
                                                VER    
                                            </a>                                               
                                        </div>
                                    </div>                           
                                </div>
                            </div>
                        </div>
                        @endforeach
                    </div>  
                    @if($productos->count() == 0)
                    <div class="row m-t-40">
                        <div class="col-12">
                            <h2 class="text-center">No tiene productos ingresados</h2>
                        </div>
                    </div>        
                    @endif
                    @if($productos->hasPages())
                    <div class="row">
                        <div class="col-12">
                            {{ $productos->links() }}
                        </div>
                    </div>          
                    @endif
                </div>
            </div>            
        </div>
    </div>
</div>

<style>
    .only-btn {
        padding: 3px;
    }
    .img-circle {
        height: 50px;
        width: 50px;
        margin: 0 auto;
        margin-top: 5px !important;
        display: block;
        float: none !important;
    }

    .btn-secondary:hover {
        color: #E7D10A !important;
        background-color: transparent;
        border-color: none;
        box-shadow: none !important;
    }

    .text-limit {
        overflow: hidden;
        text-overflow: ellipsis;
        display: -webkit-box;
        -webkit-line-clamp: 2; /* number of lines to show */
        -webkit-box-orient: vertical;
        width: 75%;
    }
    .box-link {
        font-size: 12px;
    }
    .card {
        margin-bottom: 15px;
    }
    .border-right {
        border-right: 1px solid #ccc;
        text-align: center;
    }
    .box-link {
        padding: 5px 12px;
    }

    .center-conent-v{
        display: flex;
        justify-content: center;
        flex-direction: column;
    }

    .text-calculovalor{
        font-weight: bold;
        color: #432874;
        font-size: 20px;
    }

    .font-size-11{
        font-size: 11px;
    }
    
    .content-img-p > img{
        margin-top: 0px !important; 
    }

</style>
@endsection    

resources/views/productos/afiliado/view.blade.php
@extends('layout') 
@section('content')

<div class="row page-titles">
    <div class="col-md-5 align-self-center">
        <h3 class="text-themecolor">Producto - {{$producto->nombre_p}}</h3>
    </div>
    <div class="col-md-7 align-self-center">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{{route('productos.index')}}">Productos</a></li>
            <li class="breadcrumb-item">Ver</li>
            <li class="breadcrumb-item active">{{$producto->id}}</li>
        </ol>
    </div>
    <div>
        <button class="right-side-toggle waves-effect waves-light btn-inverse btn btn-circle btn-sm pull-right m-l-10"><i class="ti-settings text-white"></i></button>
    </div>
</div>

<div class="container-fluid p-t-20">
    <div class="row">
        <div class="col-12">  
            <div class="card">
                <div class="card-body">
                    <div class="row"> 
                        <div class="col-6">
                            <div class="owl-carousel owl-theme">
                                @foreach($producto->productofotos as $item)
                                    @if($item->tipo == 'IN')
                                    <img class="d-block img-fluid owl-lazy" data-src="{{ url('storage/app/public/'.$item->url_imagen) }}">
                                    @else
                                    <img class="d-block img-fluid owl-lazy" data-src="{{ $item->url_imagen }}">
                                    @endif
                                @endforeach
                            </div>
                        </div>
                        <div class="col-6">
                            <div class="row">
                                <div class="col-md-12 d-xs-none">
                                    <div class="mt-5"><br/></div>
                                </div>
                            </div>
                            <h1 class="text-left title1">{{$producto->nombre_p}}</h1>
                            <h3 class="float-left title2 m-b-10">{{$producto->categoriap->nombre_cp}}</h3>
                            <br/>
                            
                            <div class="m-t-10" style="width: 190px;">
                                {!! $producto->yalinkeado !!}
                            </div>

                            <div class="form-group m-t-20">
                                {{$producto->descripcion}}
                            </div>

                            <div class="form-group m-t-20">
                                SKU: {{$producto->sku}}
                            </div>

                            <div class="row">
                                <div class="col-6 b-r">
                                    <h4 class="title3">VALOR ESTIMADO</h4>
                                    <h2 class="title4">${{$producto->valor}}</h2>
                                </div>
                                <div class="col-6 text-center">
                                    <h4 class="title3">PORCENTAJE</h4>
                                    <h2 class="title4">{{$producto->calculovalor}}%</h2>
                                </div>
                            </div>
                            <br/>
                            <div class="form-group m-t-20">
                                <form method="POST" action="{{ route('productos.linkear', $producto) }}">
                                    @csrf
                                    <button type="submit" class="btn-md btn-primary" style="font-weight: bold;">
                                        AGREGAR A MIS LINKS
                                    </button>
                                </form>
                            </div>
                        </div>
                    </div>                    
                </div>
            </div>
        </div>
    </div>
</div>

<link href="https://cdnjs.cloudflare.com/ajax/libs/OwlCarousel2/2.3.4/assets/owl.carousel.min.css" rel="stylesheet">

<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/OwlCarousel2/2.3.4/assets/owl.theme.default.min.css" integrity="sha512-sMXtMNL1zRzolHYKEujM2AqCLUR9F2C4/05cdbxjjLSRvMQIciEPCQZo++nk7go3BtSuK9kfa/s+a4f4i5pLkw==" crossorigin="anonymous" />

<script src="https://cdnjs.cloudflare.com/ajax/libs/OwlCarousel2/2.3.4/owl.carousel.min.js"></script>
<script>
    $(document).ready(function() {
        $('.owl-carousel').owlCarousel({
            items:1,
            lazyLoad:true,
            loop:true,
            nav:false
        });
    });
</script>

<style>
.title1 {
    font-size: 36px;
    color: #432874;
    font-weight: bold;
    text-transform: uppercase;
}
.title2, .title3 {
    text-transform: uppercase;
    font-size: 15px;
}
.title3 {
    color: #e4ce0b;
}
.title4 {
    color: #7a7a7a;
    font-size: 36px;
}
.b-r {
    border-right: 1px solid #ccc;
}
</style>

@endsection    